#include "wl_def.h"

boolean AdLibPresent, SoundBlasterPresent;

SDMode SoundMode;
SMMode MusicMode;
SDSMode DigiMode;

static boolean SD_Started = false;
static word* DigiList = NULL;

void SD_SetDigiDevice(SDSMode mode) {
	DigiMode = mode;
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_SetSoundMode() - Sets which sound hardware to use for sound effects
//
///////////////////////////////////////////////////////////////////////////
boolean SD_SetSoundMode(SDMode mode) {
	SoundMode = mode;
	return true;
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_SetMusicMode() - sets the device to use for background music
//
///////////////////////////////////////////////////////////////////////////
boolean SD_SetMusicMode(SMMode mode) {
	MusicMode = mode;
	return true;
}

/*
 * Not my wording, from sd_oss.c
 */
static void Blah()
{
        memptr  list;
        word    *p, pg;
        int     i;

        MM_GetPtr(&list,PMPageSize);
        p = PM_GetPage(ChunksInFile - 1);
        memcpy((void *)list,(void *)p,PMPageSize);
        
        pg = PMSoundStart;
        for (i = 0;i < PMPageSize / (sizeof(word) * 2);i++,p += 2)
        {
                if (pg >= ChunksInFile - 1)
                        break;
                pg += (p[1] + (PMPageSize - 1)) / PMPageSize;
        }
        MM_GetPtr((memptr *)&DigiList, i * sizeof(word) * 2);
        memcpy((void *)DigiList, (void *)list, i * sizeof(word) * 2);
        MM_FreePtr(&list);        
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_Startup() - starts up the Sound Mgr
//
///////////////////////////////////////////////////////////////////////////
void SD_Startup()
{
	if (SD_Started)
		return;
	
	Blah( );
	InitDigiMap();

	SD_SetMusicMode( smm_AdLib );
	SD_SetSoundMode( sdm_AdLib );
	SD_SetDigiDevice( sds_SoundBlaster );

	soundEnable( );

	SD_Started = true;
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_Shutdown() - shuts down the Sound Mgr
//
///////////////////////////////////////////////////////////////////////////
void SD_Shutdown()
{
	if (!SD_Started)
		return;

	SD_Started = false;
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_PlaySound() - plays the specified sound on the appropriate hardware
//
///////////////////////////////////////////////////////////////////////////
boolean SD_PlaySound( soundnames sound ) {
	int DigiSound = DigiMap[ sound ];
	int SoundPage = 0;
	int SoundLen = 0;
	char* Data;

	if ( DigiSound != -1 ) {
		SoundPage = DigiList[ ( DigiSound * 2 ) + 0 ];
		SoundLen = DigiList[ ( DigiSound * 2 ) + 1 ];

		PM_SetPageSize( SoundPage, SoundLen );
		Data = ( char* ) PM_GetSoundPage( SoundPage );

		soundPlaySample( Data, 0, SoundLen, 7000, 127, 64, false, 0 );
		return true;
	}

	return false;
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_SoundPlaying() - returns the sound number that's playing, or 0 if
//		no sound is playing
//
///////////////////////////////////////////////////////////////////////////
word SD_SoundPlaying()
{
	return false;
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_StopSound() - if a sound is playing, stops it
//
///////////////////////////////////////////////////////////////////////////
void SD_StopSound()
{
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_WaitSoundDone() - waits until the current sound is done playing
//
///////////////////////////////////////////////////////////////////////////
void SD_WaitSoundDone()
{
/* TODO: should also "work" when sound is disabled... */
	while (SD_SoundPlaying())
		;
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_MusicOn() - turns on the sequencer
//
///////////////////////////////////////////////////////////////////////////
void SD_MusicOn( ){
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_MusicOff() - turns off the sequencer and any playing notes
//
///////////////////////////////////////////////////////////////////////////
void SD_MusicOff() {
}

///////////////////////////////////////////////////////////////////////////
//
//	SD_StartMusic() - starts playing the music pointed to
//
///////////////////////////////////////////////////////////////////////////
void SD_StartMusic(int music) {
}

void PlaySoundLocGlobal(word s, int id, fixed gx,fixed gy)
{
	SD_PlaySound(s);
}

void UpdateSoundLoc(fixed x, fixed y, int angle)
{
}
